package GC;

import org.antlr.runtime.*;
import guicop.*;

public class ParseOut {

  public static void main(String[] args) throws Exception {

    if (args.length != 1)
    {
      System.err.println("missing input spec file");
      return;
    }

    // Create an TLexer that feeds from that stream
    InstrumentationLexer lexer = new InstrumentationLexer(new ANTLRFileStream(args[0]));

    // Create a stream of tokens fed by the lexer
    CommonTokenStream tokens = new CommonTokenStream(lexer);

    // Create a parser that feeds off the token stream
    InstrumentationParser parser = new InstrumentationParser(tokens);

    parser.listofproperties();
    GCSolution sol = parser.sol;
    //System.out.println("out = " + parser.specobjects().spec);
    parser.currentSpec.olog("all textrects = " + sol.textrects );
    parser.currentSpec.olog("all rects = " + sol.rects );
    parser.currentSpec.olog("all lines = " + sol.lines);
    parser.currentSpec.olog("all points = " + sol.points );
    parser.currentSpec.olog("all ellipses = " + sol.ellipses);
    parser.currentSpec.olog("all texts = " + sol.texts );
    parser.currentSpec.olog("all arcs = " + sol.arcs);
    parser.currentSpec.olog("all triangles= " + sol.triangles);

  }
}
