package guicop;
import java.util.*;

abstract public class GCBinaryOperator extends GCExpression {
  GCBinaryOperator (GCNode left, GCNode right) {
    super(left, right);
  }

  public GCNode getLeft() {
		return children.get(0);
  }

  public GCNode getRight() {
		return children.get(1);
  }

  @Override
  public BitSet getIndicesOfExpVars(BitSet who, int depth) {
    GCExpression lExpr = (GCExpression) getLeft();
    GCExpression rExpr = (GCExpression) getRight();
    who = lExpr.getIndicesOfExpVars(who,depth+1);
    who = rExpr.getIndicesOfExpVars(who,depth+1);
    return who;
  }

	@Override
	public ArrayList<GCComponent> matchExecute(int depth) {
	    assert(children.size() == 2);
      olog(depth,"matchExecute");
		ArrayList<GCComponent> leftSolution = children.get(0).match(depth+1);
		ArrayList<GCComponent> rightSolution = children.get(1).match(depth+1);
		ArrayList<GCComponent> result = executeOp(leftSolution, rightSolution);
    olog(depth,"done matchExecute. found " + result.size() + " objects");
		return result;
	}

  // all classes supporting binary operations should support this
  abstract ArrayList <GCComponent> executeOp( ArrayList<GCComponent > leftSolution , ArrayList<GCComponent > rightSolution);
}
