package guicop;
import java.util.*;

public class GCBoolean extends GCLiteral {

	public boolean value;

	public GCBoolean (String text)
	{
		value = (text.equals("true"))  ? true : false;
	}

	public GCBoolean (boolean value)
	{
		this.value = value;
	}

  public String getPrettyName() {
    return "bool";
  }

  @Override
  public int computeInt(GCCompositeComp composite, int depth) {
    return value ? 1 : 0;
  }
 
	@Override
  public ArrayList<GCComponent> matchExecute(int depth) {
    if (value == false) {
      return matches;// empty
    }
    // note: we return a one joker tuple (all solutions) because
    // 1) save memory
    // 2) when operandSol is empty, we have no way currently of getting
    // the GCUDefObj needed to construct a composite. 
    GCCompositeComp composite = new GCCompositeComp();
    composite.iVal = value ? 1 : 0;
    matches.add(composite);
    return matches;
  }

	public String toString() { return "" + value;}
}
