package guicop;
import java.util.*;

public class GCExpressionDiff extends GCBinaryOperator {

	public GCExpressionDiff (GCNode left, GCNode right) {
    super(left, right);
	}

 @Override
  public String getPrettyName() {
    return "!=";
  }

  @Override
  public int computeInt(GCCompositeComp composite, int depth){
	  GCExpression expr1 = (GCExpression) getLeft();
	  GCExpression expr2 = (GCExpression) getRight();
    int val1 = expr1.computeInt(composite, depth+1);
    int val2 = expr2.computeInt(composite, depth+1);
    return val1!=val2 ? 1 : 0;
  }

  public ArrayList <GCComponent> executeOp(ArrayList<GCComponent > leftSolution , ArrayList<GCComponent > rightSolution) {
    for (GCComponent comp1 : leftSolution) {
      for (GCComponent comp2 : rightSolution) {
        // <joker,joker,...,joker>.text = concatenation
        olog(comp1.getIntValue() + "!=" + comp2.getIntValue());
        if (comp1.getIntValue() != comp2.getIntValue ()) {
          try {
            GCCompositeComp composite = new GCCompositeComp (comp1.composite(),comp2.composite());
            composite.iVal = 1;
            matches.add(composite);
          } catch (Exception e) {
            olog(GCNode.sol.depth,"conflict in creating composite object");
          }
        }
      }
    }
    return matches;

  }
 
	

	public String toString() { return getLeft() + " != " + getRight()+ "\n";}
}
