package guicop;
import java.util.*;

public class GCExpressionDiv extends GCBinaryOperator {

	public GCExpressionDiv (GCNode left, GCNode right) {
    super(left, right);
	}

 @Override
  public String getPrettyName() {
    return "/" ;
  }
 
  @Override
  public int computeInt(GCCompositeComp composite, int depth){
	  GCExpression expr1 = (GCExpression) getLeft();
	  GCExpression expr2 = (GCExpression) getRight();
    int val1 = expr1.computeInt(composite, depth+1);
    int val2 = expr2.computeInt(composite, depth+1);
    return val1 / val2;
  }

	
  public ArrayList <GCComponent> executeOp(ArrayList<GCComponent > leftSolution , ArrayList<GCComponent > rightSolution) {
    for (GCComponent comp1 : leftSolution) {
      for (GCComponent comp2 : rightSolution) {
        // <joker,joker,...,joker>.text = concatenation
        try {
          GCCompositeComp composite = new GCCompositeComp (comp1.composite(),comp2.composite());
          try {
            composite.iVal = comp1.getIntValue() / comp2.getIntValue ();
          } catch (Exception e) {
            olog(GCNode.sol.depth, "division by zero?");
          }
          matches.add(composite);
        } catch (Exception e) {
          olog(GCNode.sol.depth, "conflict in creating composite object");
        }
      }
    }
    return matches;
  }

	public String toString() { 
    return getLeft() + " Div " + getRight() + "\n";}

}
