package guicop;
import java.util.*;

public class GCExpressionNot extends GCUnaryOperator {
	public GCNode operand;

	public GCExpressionNot(GCNode operand) {
    super(operand);
	}

 @Override
  public String getPrettyName() {
    return "not" ;
  }
 
  @Override
  public int computeInt(GCCompositeComp composite, int depth){
	  GCExpression expr1 = (GCExpression) operand;
    int val1 = expr1.computeInt(composite, depth+1);

    return (val1 == 0) ? 1 : 0;
  }
	
  ArrayList <GCComponent> executeOp( ArrayList<GCComponent > operandSolution ) {
    if (operandSolution.isEmpty()){
      //complement the empty set by a joker (all) solution
      // note: we return a one joker tuple because
      // 1) save memory
      // 2) when operandSol is empty, we have no way currently of getting
      // the GCUDefObj needed to construct a composite. 
      GCCompositeComp composite = new GCCompositeComp();
      matches.add(composite);
      return matches;
    }
    // get the object from one of the composite components
    GCCompositeComp comp = operandSolution.get(0).composite();
    GCUDefObj obj = comp.obj;
    // compute all solutions -- universe
    ArrayList<GCComponent> all = obj.computeAllSolutions();

    // take the difference between all and operandSolution
    for(GCComponent comp1 : all) {
      boolean found = false;
      for (GCComponent comp2 : operandSolution) {
        //if (comp1 == comp2) {
        if (comp1.isEqual(comp2) ){
          found = true;
          break;
        }
      }
      if (!found) {
        matches.add(comp1);
      }
    }

    return matches;
  }

	public String toString() { return " Not " + operand + "\n";}

	
}
