package guicop;
import java.util.*;

public class GCExpressionOr extends GCBinaryOperator {

	public GCExpressionOr(GCNode left, GCNode right) {
    super(left, right);
	}

  @Override
  public String getPrettyName() {
    return "or";
  }

  @Override
  public int computeInt(GCCompositeComp composite, int depth) {

    GCExpression lExpr = (GCExpression) getLeft();
    int res1 = lExpr.computeInt(composite, depth+1);
    if (res1 == 1) {
      return 1;
    }

    GCExpression rExpr = (GCExpression) getRight();
    int res2 = rExpr.computeInt(composite, depth+1);
    if (res2 == 1) {
      return 1;
    }
    return 0;
  }

 @Override
 public ArrayList <GCComponent> executeOp(ArrayList<GCComponent > leftSolution , ArrayList<GCComponent > rightSolution) {
   //initialize matches to left
   matches = leftSolution;

   //add  a match from right if it did not exist already in left
   for (GCComponent comp1 : rightSolution) {
     boolean notFound = true;
     for (GCComponent comp2 : leftSolution) {
       if (comp1.isEqual(comp2)) {
         notFound = false;
         break;
       }
     }
     if (notFound) {
       matches.add(comp1);
     }
   }
   return matches;
 }

	public String toString() { return getLeft() + " Or " + getRight() + "\n";}
	
}
