package guicop;
import java.util.*;

public class GCExpressionPlus extends GCBinaryOperator {

	public GCExpressionPlus(GCNode left, GCNode right) {
    super(left, right);
	}

 @Override
  public String getPrettyName() {
    return "+";
  }
  @Override
  public int computeInt(GCCompositeComp composite, int depth){
	  GCExpression expr1 = (GCExpression) getLeft();
	  GCExpression expr2 = (GCExpression) getRight();
    int val1 = expr1.computeInt(composite, depth+1);
    int val2 = expr2.computeInt(composite, depth+1);
    return val1 + val2;
  }

  public ArrayList <GCComponent> executeOp(ArrayList<GCComponent > leftSolution , ArrayList<GCComponent > rightSolution) {
    olog(GCNode.sol.depth,"executeOp, starting with " + Integer.toString(matches.size()) + " objects");
    for (GCComponent comp1 : leftSolution) {
      for (GCComponent comp2 : rightSolution) {
        // <joker,joker,...,joker>.text = concatenation
        try {
          GCCompositeComp composite = new GCCompositeComp (comp1.composite(),comp2.composite());
          composite.iVal = comp1.getIntValue() + comp2.getIntValue();
          matches.add(composite);
        } catch (Exception e) {
          elog(GCNode.sol.depth, "conflict in creating composite object");
        }
      }
    }
    olog(GCNode.sol.depth,"found " + Integer.toString(matches.size()) + " objects");
    return matches;
  }

	public String toString() { return getLeft() + " Plus " + getRight() + "\n";}
}
