package guicop;
import java.util.*;

public class GCExpressionStrEqual extends GCBinaryOperator {

	public GCExpressionStrEqual (GCNode left, GCNode right) {
    super(left, right);
	}

 @Override
  public String getPrettyName() {
    return "strEq";
  }

  @Override
  public int computeInt(GCCompositeComp composite, int depth){
	  GCExpression expr1 = (GCExpression) getLeft();
	  GCExpression expr2 = (GCExpression) getRight();
    String val1 = expr1.computeText(composite, depth+1);
    String val2 = expr2.computeText(composite, depth+1);
    return val1.equals(val2) ? 1 : 0;
  }

  public ArrayList <GCComponent> executeOp(ArrayList<GCComponent > leftSolution , ArrayList<GCComponent > rightSolution) {
    for (GCComponent comp1 : leftSolution) {
      for (GCComponent comp2 : rightSolution) {
        // <joker,joker,...,joker>.text = concatenation
        olog(comp1.getStringValue() + " str equals " + comp2.getStringValue());
        if(comp1.getStringValue().equals(comp2.getStringValue()) ){
          try {
            GCCompositeComp composite = new GCCompositeComp (comp1.composite(),comp2.composite());
            composite.iVal = 1;
            matches.add(composite);
          } catch (Exception e) {
            olog(GCNode.sol.depth,"conflict in creating composite object");
          }
        }
      }
    }
    return matches;

  }

	public String toString() { return getLeft() + " strEquals " + getRight()+ "\n";}
	
}
