package guicop;
import java.util.*;

public class GCMemberVariable extends GCExpression {

	public GCVar object;
	public String attribute;

	public GCMemberVariable(GCVar object, String attribute)
	{
		this.object = object;
		this.attribute = attribute;	
	}

  int getObjectOrderInComposite(GCUDefObj obj) {
    return object.index;
    //for(int i=0; i < obj.variables.size(); i++) {
    //  GCVar var = obj.variables.get(i);
    //  if (var == object) {
    //    return i;
    //  }
    //}
    // object must be found!
    //assert(false);
    //return -1;
  }

  public String getPrettyName() {
    return object.name + "." + attribute;
  }

	@Override
  public int computeInt(GCCompositeComp composite, int depth){
    olog ("computing int value of " + object.name + "." + attribute);
    if (attribute.compareToIgnoreCase("x") == 0) {
      return composite.getX();
    } else if (attribute.compareToIgnoreCase("y") == 0) {
      return composite.getY();
    } else if (attribute.compareToIgnoreCase("width") == 0) {
      return composite.getWidth();
    } else if (attribute.compareToIgnoreCase("height") == 0) {
      return composite.getHeight();
    } else if (attribute.compareToIgnoreCase("x1") == 0) {
      return composite.getX();
    } else if (attribute.compareToIgnoreCase("y1") == 0) {
      return composite.getY();
    } 
    return composite.intProperties.get(attribute);
  }
      
  public String computeText(GCCompositeComp composite, int depth) {
    olog ("computing text value of " + object.name + "." + attribute);
    if (attribute.compareToIgnoreCase("string") == 0) {
      return composite.getText();
    } else if (attribute.compareToIgnoreCase("text") == 0) {
      return composite.getText();
    } 
    return composite.textProperties.get(attribute);
  }


	@Override
	public ArrayList<GCComponent> matchExecute(int depth) {
    ArrayList<GCComponent> varComps = object.match(depth+1);
    if (varComps.isEmpty()){
      return varComps;
    }
    // check what is the order of object in the composite
    // array. We need that to get the attribute from 
    // the right part of the composite
    GCCompositeComp composite1 = varComps.get(0).composite();
    int order = getObjectOrderInComposite(composite1.obj);

    for ( GCComponent compiter : varComps) {
      GCCompositeComp composite = compiter.composite().clone();
      GCComponent comp = composite.components[order];
      if (attribute.compareToIgnoreCase("x") == 0) {
        composite.iVal = comp.getX();
      } else if (attribute.compareToIgnoreCase("y") == 0) {
        composite.iVal = comp.getY();
      } else if (attribute.compareToIgnoreCase("width") == 0) {
        composite.iVal = comp.getWidth();
      } else if (attribute.compareToIgnoreCase("height") == 0) {
        composite.iVal = comp.getHeight();
      } else if (attribute.compareToIgnoreCase("text") == 0) {
        composite.strVal = comp.getText();
      } else if (attribute.compareToIgnoreCase("string") == 0) {
        composite.strVal = comp.getText();
      } else if (attribute.compareToIgnoreCase("x1") == 0) {
          composite.iVal = comp.getX();
      } else if (attribute.compareToIgnoreCase("x2") == 0) {
        if (comp.isLine()) {
          composite.iVal = ((GCLineComp) comp).getX2();
        } 
      } else if (attribute.compareToIgnoreCase("y1") == 0) {
          composite.iVal = comp.getY();
      } else if (attribute.compareToIgnoreCase("y2") == 0) {
        if (comp.isLine()) {
          composite.iVal = ((GCLineComp) comp).getY2();
        } 
      } else {
        //resolve user defined properties by looking them
        // up in the corresponding hash tables.
        if (comp.composite() == null) {
          elog(depth,"using attribute " + attribute + " with non-composite object");
          continue;
        }
        String str = comp.composite().textProperties.get(attribute);
        if (str!=null) {
          composite.strVal = str;
        } else {
          composite.iVal = comp.composite().intProperties.get(attribute);
        }
      }
      olog (" i:" +  composite.iVal + " s:" + composite.strVal);
      matches.add(composite);
    }
		return matches;
	}

	public String toString() { return object + "." + attribute;}
}
