package guicop;
import java.util.*;

abstract public class GCNode {
  public static GCSolution sol =null;

  public ArrayList<GCNode> children = new ArrayList<GCNode>();
  public boolean isMatched = false;
  ArrayList<GCComponent> matches = new ArrayList<GCComponent> ();

  static public int maxDepth = 1000;

  static String spaces = "                                                                                                                                                                                                                                                                                                                                                          ";


  public int getX() { return 0;}
  public int getY() { return 0;}
  public int getWidth() { return 0;}
  public int getHeight() { return 0;}
  public String getText() { return "";}
  public String getString() { return getText();}

  GCNode() {
  }

  GCNode( GCNode left) {
      children.add(left);
  }

  GCNode(GCNode left, GCNode right) {
      children.add(left);
      children.add(right);
  }
  public ArrayList<GCComponent> getMatches() { return matches;}

  static public String indent(int depth) {
    return spaces.substring(0,2*depth);
  }

  public void olog(String str) {
    if (sol.depth > maxDepth) return;
    //System.out.println(Integer.toString(sol.depth) + indent(sol.depth) + " " + getPrettyName() + ": " + str);
    sol.ofile.println(Integer.toString(sol.depth) + indent(sol.depth) + " " + getPrettyName() + ": " + str);
    sol.ofile.flush();
  }

  static public void solog(int depth, String str) {
    if (sol.depth > maxDepth) return;
    sol.ofile.println(Integer.toString(depth) + indent(depth) + "NoNode: " + str);
    sol.ofile.flush();
  }

  public void olog(int depth, String str) {
    if (sol.depth > maxDepth) return;
    //System.out.println(Integer.toString(depth) + indent(depth) + " " + getPrettyName() + ": " + str);
    sol.ofile.println(Integer.toString(depth) + indent(depth) + " " + getPrettyName() + ": " + str);
    sol.ofile.flush();
  }

  public void elog(String str) {
    if (sol.depth > maxDepth) return;
    System.err.println(Integer.toString(sol.depth) + indent(sol.depth) + " " + getPrettyName() + ": " + str);
  }

  public void elog(int depth, String str) {
    if (sol.depth > maxDepth) return;
    System.err.println(Integer.toString(depth) + indent(depth) + " " + getPrettyName() + ": " + str);
  }

  public String getPrettyName() {
    return "";
  }

	public ArrayList<GCComponent> match(int depth) {
    int oldDepth = sol.depth;
    sol.depth = depth;

    olog("Starting match. {");
    if (isMatched) {
      olog("}. End match. Already computed. return cached.");
      sol.depth = oldDepth;
      return matches;
    }
    isMatched = true;
    matches = matchExecute(depth);
    olog("}. End match. Found " + Integer.toString(matches.size()) + " objects.");
    sol.depth = oldDepth;
    return matches;
  };

	abstract ArrayList<GCComponent> matchExecute(int depth) ;

}
