package guicop;
import java.util.*;
import java.io.*;

public class GCSolution {
  public ArrayList<GCComponent> textrects = new ArrayList<GCComponent>();
  public ArrayList<GCComponent> rects = new ArrayList<GCComponent>();
  public ArrayList<GCComponent> lines = new ArrayList<GCComponent>();
  public ArrayList<GCComponent> ellipses = new ArrayList<GCComponent>();
  public ArrayList<GCComponent> polygons = new ArrayList<GCComponent>();
  public ArrayList<GCComponent> triangles = new ArrayList<GCComponent>();
  public ArrayList<GCComponent> arcs = new ArrayList<GCComponent>();
  public ArrayList<GCComponent> texts = new ArrayList<GCComponent>();
  public ArrayList<GCComponent> points = new ArrayList<GCComponent>();

  public ArrayList<GCUDefObj> specs = null;
  public GCUDefObj currentObj = null;
  public int depth = 0;
  public PrintWriter ofile = null;

  public ArrayList<GCComponent> matchesFromType(String type, int depth) {
    // check if type is user defined first
    for(GCUDefObj obj : specs) {
      if (obj.name.equals(type)) {
        GCUDefObj prevObj = currentObj;
        currentObj = obj;
        ArrayList<GCComponent> matches = obj.match(depth+1);
        currentObj = prevObj;
        return matches;
      }
    }
    // check for primitive types
    if( type.equalsIgnoreCase("rectangle")) {
      return rects;
    }
    if( type.equalsIgnoreCase("textrect")) {
      return textrects;
    }
    if( type.equalsIgnoreCase("line")) {
      return lines;
    }
    if( type.equalsIgnoreCase("ellipse")) {
      return ellipses;
    }
    if( type.equalsIgnoreCase("polygon")) {
      return polygons;
    }
    if( type.equalsIgnoreCase("triangle")) {
      return triangles;
    }
    if( type.equalsIgnoreCase("arc")) {
      return arcs;
    }
    if( type.equalsIgnoreCase("text")) {
      return texts;
    }
    if( type.equalsIgnoreCase("point")) {
      return points;
    }
    System.err.println("type " + type + " is not defined. no matches");
    return null;
  }
  
  public GCSolution(String specname) {
    try{ 
    ofile = new PrintWriter("guicop."+specname+".out","UTF-8");
    } catch (Exception e){
      System.err.println("Error opening file");
      System.err.println(e);
    }
  }
  public void finalize(){
    ofile.close();
  }
}
