package guicop;
import java.util.*;

public class GCVar extends GCExpression {
	public String type;
	public String name;
  public boolean isFlexible;
  public int index;// the index corresponding to this variable 
                   // in the composite.components array matching
                   // the containing object.


	public GCVar(String name, String type) {
    this.name = name; 
    this.type = type;
    this.isFlexible=false;
  }
	public GCVar(String name, String type, boolean isFlexible) {
    this.name = name; 
    this.type = type;
    this.isFlexible=isFlexible;
  }
	
	public ArrayList<GCComponent> matchExecute(int depth) {
    // refer to the type to get the matches
    olog(depth,"matchExecute");
	  ArrayList<GCComponent> compMatches = GCNode.sol.matchesFromType(type,depth);
    if (compMatches != null) {
      matches = compMatches;
    }
    olog(depth,"matchExecute done. found " + Integer.toString(matches.size()) + " objects");
    return matches;
  }
 @Override
  public String getPrettyName() {
    return type +":"+ name;
  }

  @Override
  public BitSet getIndicesOfExpVars(BitSet who, int depth) {
    who.set(index,true);
    return who;
  }

  @Override
  public int computeInt(GCCompositeComp composite, int depth) {
    return composite.getIntValue();
  }

  public void makeMatchesComposite(int order, GCUDefObj obj) {
    ArrayList<GCComponent> compositeMatches = new ArrayList<GCComponent> ();
    if (type.compareToIgnoreCase("line") == 0) {
      for ( GCComponent comp : matches) {
        GCLineComp lcomp = (GCLineComp) comp;
        GCCompositeComp composite = new GCCompositeComp (obj, order, comp);
        composite.intProperties.put("x2",lcomp.getX2());
        composite.intProperties.put("y2",lcomp.getY2());
        compositeMatches.add(composite);
      }
    } else {
      for ( GCComponent comp : matches) {
        GCCompositeComp composite = new GCCompositeComp (obj, order, comp);
        compositeMatches.add(composite);
      }
    }
    matches = compositeMatches;
  }

	public String toString() { return "[" + type+ "]." + name; }
}
